#pragma once
// PKCS#11 ls11sw library-specific definitions

#ifdef __cplusplus
extern "C"
{
#endif

#include "pkcs11types.h"

#ifndef PKCS11_NUMBER_SLOTS_MANAGED
#define PKCS11_NUMBER_SLOTS_MANAGED 1
#endif

#define PKCS11_DEFAULT_SW_TOKEN_ID (PKCS11_NUMBER_SLOTS_MANAGED - 1)

typedef enum {
    PKCS11_CTRL_EMPTY,			// not used
    PKCS11_CTRL_OPEN_TOKEN,		
    PKCS11_CTRL_CLOSE_TOKEN,	// not used
    PKCS11_CTRL_SEED_PATH,		// not used
    PKCS11_CTRL_SEED_CALLBACK,	// not used
    PKCS11_CTRL_LICENSE_IN,		// not used
    PKCS11_CTRL_LICENSE_OUT,	// not used
	PKCS11_CTRL_LOG_PATH,
	PKCS11_CTRL_FORMAT_TOKEN,	// not used
    PKCS11_CTRL_MAX,
} PKCS11_CTRL;

// Additional API function type for LS11SW configuring
typedef CK_RV (CK_PTR CK_C_Ctrl)
	(int cmd, long i, void *p, void(*f)(void));

typedef enum {
    TOKEN_TYPE_EMPTY,
    TOKEN_TYPE_FILE_SYSTEM,			// for software token
    TOKEN_TYPE_HW_TOKEN,			// not used
    TOKEN_TYPE_HW_SLOT,				// not used
	TOKEN_TYPE_JAVA_CARD,			// not used
	TOKEN_TYPE_MEMORY,				// not used
	TOKEN_TYPE_REGISTRY,			// not used
	TOKEN_TYPE_LSMS11_SMART_CARD,	// not used	
	TOKEN_TYPE_UNSUPPORTED,			// for unsupported token
    TOKEN_TYPE_MAX,
} TOKEN_TYPE;

#ifdef __cplusplus
}
#endif

